﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	
	import flash.external.ExternalInterface;
	import flash.events.MouseEvent;
	import com.as3facile.DefaultButton;
	import com.actionscriptfacile.ui.text.UITextField;
	
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	import com.demonsters.debugger.MonsterDebugger;


	public class Main extends Sprite
	{
		private var oTxtInput : UITextField;
		
		private var bJsDispo : Boolean;

		
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}
		

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			// test si possibilité de communication avec javascript
			bJsDispo = ExternalInterface.available;
			MonsterDebugger.trace(this, ExternalInterface);
			
			this.setupUI();	
		}


		/**
		 * Affiche les champs textes.
		 * 
		 */
		private function setupUI() : void
		{
			oTxtInput = this.createTextInput("Saisissez votre texte pour html :");
			oTxtInput.x = 10;
			oTxtInput.y = 10;
			this.addChild(oTxtInput);
			
			// si la communication avec javascript est impossible
			if( !bJsDispo )
			{
				oTxtInput.text = "Communication avec javascript impossible !";
				oTxtInput.convertToDynamic();
				oTxtInput.selectable = false;
				
				oTxtInput.changeFormat("size", 20);// changement de la taille de la police du texte
				oTxtInput.changeFormat("color", 0xFF0000);// changement de la couleur
				return;
			}
			
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "Mettre à jour le texte HTML";
			oBtnStart.getObject().x = 230;
			oBtnStart.getObject().y = oTxtInput.y + oTxtInput.height + 20;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onUpdateJs );
			this.addChild(oBtnStart);
			
			// enregistre la fonction directement appelée par javascript
			ExternalInterface.addCallback("callFlash",	onUpdateTextFromJs);// fonction côté javascript - fonction actionscript
		}
		
		
		/**
		 * Appel par le javascript.
		 * 
		 */
		private function onUpdateTextFromJs(sValue:String) : void
		{
			MonsterDebugger.trace(this, onUpdateTextFromJs);
			MonsterDebugger.trace(this, sValue);
			oTxtInput.text = sValue;
		}

		
		/**
		 * Communique avec javascript.
		 * Mets à jour le texte html.
		 * 
		 */
		private function onUpdateJs(event : MouseEvent) : void
		{
			MonsterDebugger.trace(this, onUpdateJs);
			MonsterDebugger.trace(this, oTxtInput.htmlText);
			ExternalInterface.call("updateTextHtml", oTxtInput.htmlText);// appel de la fonction javascript
		}
		
		
		
		
		/**
		 * Création d'un champ texte de saisie.
		 * 
		 */
		private function createTextInput(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			
			oTxtField.autoSizeNone();
			oTxtField.multiline = true;
			oTxtField.maxHeight = oTxtField.height = 130;
			oTxtField.maxWidth = oTxtField.width = 490;
			oTxtField.border = true;
			oTxtField.borderColor = 0x00C5DF;
			
			oTxtField.convertToInput();
			oTxtField.alignLeft();
			
			oTxtField.changeFormat("size", 12);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}
		
	}
}
